## org.apache.xalan.xsltc.dom
Class StepIterator

    java.lang.Object
      org.apache.xml.dtm.ref.DTMAxisIteratorBase
          org.apache.xalan.xsltc.dom.StepIterator

All Implemented Interfaces:
  java.lang.Cloneable, DTMAxisIterator

Direct Known Subclasses:
  FilteredStepIterator

    public class StepIterator

extends DTMAxisIteratorBase

A step iterator is used to evaluate expressions like "BOOK/TITLE". A better name for this iterator would have been ParentIterator since both "BOOK" and "TITLE" are steps in XPath lingo. Step iterators are constructed from two other iterators which we are going to refer to as "outer" and "inner". Every node from the outer iterator (the one for BOOK in our example) is used to initialize the inner iterator. After this initialization, every node from the inner iterator is returned (in essence, implementing a "nested loop").

Author:
  Jacek Ambroziak, Santiago Pericas-Geertsen, Erwin Bolwidt <ejb@klomp.org>, Morten Jorgensen

Field Summary

Fields inherited from interface org.apache.xml.dtm.DTMAxisIterator
`END`

Constructor Summary
`StepIterator(DTMAxisIterator source, DTMAxisIterator iterator)`

Method Summary
`DTMAxisIterator` `cloneIterator()` Returns a deep copy of this iterator.
`void` `gotoMark()` Restores the current node remembered by setMark().
`int` `next()` Get the next node in the iteration.
`DTMAxisIterator` `reset()` Resets the iterator to the last start node.
`void` `setMark()` Remembers the current node for the next call to gotoMark().
`void` `setRestartable(boolean isRestartable)` Set if restartable.
`DTMAxisIterator` `setStartNode(int node)` Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

Methods inherited from class org.apache.xml.dtm.ref.DTMAxisIteratorBase
`getAxis, getLast, getNodeByPosition, getPosition, getStartNode, includeSelf, isDocOrdered, isReverse`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StepIterator

    public StepIterator(DTMAxisIterator source,
                        DTMAxisIterator iterator)

Method Detail

### setRestartable

    public void setRestartable(boolean isRestartable)

  Description copied from interface: `DTMAxisIterator`
  Set if restartable.

  Specified by:
    `setRestartable` in interface `DTMAxisIterator`
  Overrides:
    `setRestartable` in class `DTMAxisIteratorBase`

### cloneIterator

    public DTMAxisIterator cloneIterator()

  Description copied from class: `DTMAxisIteratorBase`
  Returns a deep copy of this iterator. Cloned iterators may not be restartable. The iterator being cloned may or may not become non-restartable as a side effect of this operation.

  Specified by:
    `cloneIterator` in interface `DTMAxisIterator`
  Overrides:
    `cloneIterator` in class `DTMAxisIteratorBase`
  Returns:
    a deep copy of this iterator.

### setStartNode

    public DTMAxisIterator setStartNode(int node)

  Description copied from interface: `DTMAxisIterator`
  Set start to END should 'close' the iterator, i.e. subsequent call to next() should return END.

  Parameters:
    `node` - Sets the root of the iteration.
  Returns:
    A DTMAxisIterator set to the start of the iteration.

### reset

    public DTMAxisIterator reset()

  Description copied from interface: `DTMAxisIterator`
  Resets the iterator to the last start node.

  Specified by:
    `reset` in interface `DTMAxisIterator`
  Overrides:
    `reset` in class `DTMAxisIteratorBase`
  Returns:
    A DTMAxisIterator which has been reset to the start node, which may or may not be the same as this iterator.

### next

    public int next()

  Description copied from interface: `DTMAxisIterator`
  Get the next node in the iteration.

  Returns:
    The next node handle in the iteration, or END.

### setMark

    public void setMark()

  Description copied from interface: `DTMAxisIterator`
  Remembers the current node for the next call to gotoMark().

### gotoMark

    public void gotoMark()

  Description copied from interface: `DTMAxisIterator`
  Restores the current node remembered by setMark().

Copyright © 2005 Apache XML Project. All Rights Reserved.